<?php

class IMAPServerInformation
{
	protected $imap = null;

	public function __construct()
	{
		$this->imap = IMAPManager::getAdminConnection();
	}
	
	public function getGreeting()
	{
		return substr($this->imap->getGreeting(), 5);
	}
	
	public function getServerName()
	{
		return $this->imap->getServerName();
	}
	
	public function getServerVersion()
	{
		return $this->imap->getServerVersion();
	}
	
	public function hasCapability($name)
	{
		return $this->imap->hasCapability($name);
	}
	
	public function getCapabilties()
	{
		if(!($c = $this->imap->capability()))
			$c = array();
		return $c;
	}
	
	public function getHierarchyDelimiter()
	{
		return $this->imap->getHierarchyDelimiter();
	}
	
	public function getAvailableACL()
	{
		if(!$this->imap->hasCapability('ACL'))
			return false;
		
		return $this->imap->getAvailableACL();
	}
	
	public function getHost()
	{
		return substr($this->imap->getURI(), 0, strpos($this->imap->getURI(), ":"));
	}
	
	public function getPort()
	{
		return substr($this->imap->getURI(), strpos($this->imap->getURI(), ":")+1);
	}
}

?>
