<?php

/**
 * Subclass for performing query and update operations on the 'domain' table.
 *
 * 
 *
 * @package lib.model
 */ 
class DomainPeer extends BaseDomainPeer
{
	// only return results according to domain permissions
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
		DomainPermissionPeer::addDomainPermissionCriteria($criteria, DomainPeer::ID);
		return parent::doCount($criteria, $distinct, $con);
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		DomainPermissionPeer::addDomainPermissionCriteria($criteria, DomainPeer::ID);
		return parent::doSelect($criteria, $con);
	}

	public static function doSelectJoinUser(Criteria $criteria, $con = null)
	{
		DomainPermissionPeer::addDomainPermissionCriteria($criteria, DomainPeer::ID);
		return parent::doSelectJoinUser($criteria, $con);
	}

	public static function getDomainByName($name)
	{
		$c = new Criteria();
		$c->add(self::NAME, $name);
		return self::doSelect($c);
	}
}
