<?php

/**
 * Subclass for representing a row from the 'log' table.
 *
 * 
 *
 * @package lib.model
 */ 
class LogEntry extends BaseLogEntry
{
	const PRIO_DEBUG = 0;
	const PRIO_INFO = 1;
	const PRIO_NOTICE = 2;
	const PRIO_WARNING = 3;
	const PRIO_ERROR = 4;
	const PRIO_CRITICAL = 5;
	const PRIO_ALERT = 6;
	const PRIO_EMERGENCY = 7;

	public function getLevel()
	{
		// emerg, alert, crit, err, warning, notice, info, and debug
		switch($this->getPriority())
		{
			case 0: return "Debug";
			case 1: return "Info";
			case 2: return "Notice";
			case 3: return "Warning";
			case 4: return "Error";
			case 5: return "Critical";
			case 6: return "Alert";
			case 7: return "Emergency";
			default:
				return "Unknown";
		}
	}
}
