<?php

/**
 * Subclass for performing query and update operations on the 'mailbox' table.
 *
 * 
 *
 * @package lib.model
 */ 
class MailboxPeer extends BaseMailboxPeer
{
	// only return results according to domain permissions
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
		DomainPermissionPeer::addDomainPermissionCriteria($criteria, MailboxPeer::DOMAIN_ID);
		return parent::doCount($criteria, $distinct, $con);
	}

	public static function doSelect(Criteria $criteria, $con = null)
	{
		DomainPermissionPeer::addDomainPermissionCriteria($criteria, MailboxPeer::DOMAIN_ID);
		return parent::doSelect($criteria, $con);
	}

	public static function doSelectJoinDomain(Criteria $criteria, $con = null)
	{
		DomainPermissionPeer::addDomainPermissionCriteria($criteria, MailboxPeer::DOMAIN_ID);
		return parent::doSelectJoinDomain($criteria, $con);
	}
}
