<?php



class AddressMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.AddressMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('address');
		$tMap->setPhpName('Address');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addForeignKey('MAILBOX_ID', 'MailboxId', 'int', CreoleTypes::INTEGER, 'mailbox', 'ID', false, null);

		$tMap->addColumn('LOCALPART', 'Localpart', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addForeignKey('DOMAIN_ID', 'DomainId', 'int', CreoleTypes::INTEGER, 'domain', 'ID', false, null);

		$tMap->addColumn('ALIAS', 'Alias', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('DESTINATION', 'Destination', 'string', CreoleTypes::LONGVARCHAR, false, null);

		$tMap->addColumn('ACTIVE', 'Active', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('SAVE_IN_MAILBOX', 'SaveInMailbox', 'boolean', CreoleTypes::BOOLEAN, false, null);

	} 
} 